<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/ttt_info_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>08/22/83  ttt_info_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>
<span id="L4" class="LineNr">  4 </span>The ttt_info_ subroutine extracts information from the terminal type
<span id="L5" class="LineNr">  5 </span>table <span class="textRainbow_lv0_p0">(</span>TTT<span class="textRainbow_lv0_p0">)</span>.
<span id="L6" class="LineNr">  6 </span>
<span id="L7" class="LineNr">  7 </span>
<span id="L8" class="LineNr">  8 </span>Entry points in ttt_info_:
<span id="L9" class="LineNr">  9 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L10" class="LineNr"> 10 </span>
<span id="L11" class="LineNr"> 11 </span>
<span id="L12" class="LineNr"> 12 </span>:Entry:  additional_info:  05/04/83 ttt_info_$additional_info
<span id="L13" class="LineNr"> 13 </span>
<span id="L14" class="LineNr"> 14 </span>
<span id="L15" class="LineNr"> 15 </span>Function:  This entry point returns additional information for a
<span id="L16" class="LineNr"> 16 </span>specified terminal type to be used by I/O modules other than tty_.
<span id="L17" class="LineNr"> 17 </span>
<span id="L18" class="LineNr"> 18 </span>
<span id="L19" class="LineNr"> 19 </span>Syntax:
<span id="L20" class="LineNr"> 20 </span>declare ttt_info_$additional_info entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span> varying<span class="textRainbow_lv0_o0">,</span>
<span id="L21" class="LineNr"> 21 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L22" class="LineNr"> 22 </span>call ttt_info_$additional_info <span class="textRainbow_lv0_p0">(</span>tt_name<span class="textRainbow_lv0_o0">,</span> add_info<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L23" class="LineNr"> 23 </span>
<span id="L24" class="LineNr"> 24 </span>
<span id="L25" class="LineNr"> 25 </span>Arguments:
<span id="L26" class="LineNr"> 26 </span>tt_name
<span id="L27" class="LineNr"> 27 </span>   is the terminal type name.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L28" class="LineNr"> 28 </span>add_info
<span id="L29" class="LineNr"> 29 </span>   is the additional information string.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>.  If no additional
<span id="L30" class="LineNr"> 30 </span>   information is defined for the terminal type, a null string is
<span id="L31" class="LineNr"> 31 </span>   returned.  Maximum length is 512 characters.
<span id="L32" class="LineNr"> 32 </span>code
<span id="L33" class="LineNr"> 33 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L34" class="LineNr"> 34 </span>
<span id="L35" class="LineNr"> 35 </span>
<span id="L36" class="LineNr"> 36 </span>:Entry:  decode_answerback:  05/04/83 ttt_info_$decode_answerback
<span id="L37" class="LineNr"> 37 </span>
<span id="L38" class="LineNr"> 38 </span>
<span id="L39" class="LineNr"> 39 </span>Function:  This entry point decodes a specified answerback string into
<span id="L40" class="LineNr"> 40 </span>a terminal type name and terminal identifier.
<span id="L41" class="LineNr"> 41 </span>
<span id="L42" class="LineNr"> 42 </span>
<span id="L43" class="LineNr"> 43 </span>Syntax:
<span id="L44" class="LineNr"> 44 </span>declare ttt_info_$decode_answerback entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L45" class="LineNr"> 45 </span>     char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L46" class="LineNr"> 46 </span>call ttt_info_$decode_answerback <span class="textRainbow_lv0_p0">(</span>ansb<span class="textRainbow_lv0_o0">,</span> line_type<span class="textRainbow_lv0_o0">,</span> tt_name<span class="textRainbow_lv0_o0">,</span> id<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L47" class="LineNr"> 47 </span>
<span id="L48" class="LineNr"> 48 </span>
<span id="L49" class="LineNr"> 49 </span>Arguments:
<span id="L50" class="LineNr"> 50 </span>ansb
<span id="L51" class="LineNr"> 51 </span>   is the answerback string.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L52" class="LineNr"> 52 </span>line_type
<span id="L53" class="LineNr"> 53 </span>   is a line type number with which the decoded terminal type must be
<span id="L54" class="LineNr"> 54 </span>   compatible.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>.  A nonpositive line type number is ignored.
<span id="L55" class="LineNr"> 55 </span>   For further description, see the tty_ I/O module.
<span id="L56" class="LineNr"> 56 </span>tt_name
<span id="L57" class="LineNr"> 57 </span>   is the terminal type name decoded from the answerback.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>.
<span id="L58" class="LineNr"> 58 </span>   Its length should be at least 32 characters.  If no terminal type is
<span id="L59" class="LineNr"> 59 </span>   indicated, a null string is returned.
<span id="L60" class="LineNr"> 60 </span>id
<span id="L61" class="LineNr"> 61 </span>   is the terminal identifier decoded from the answerback.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>.
<span id="L62" class="LineNr"> 62 </span>   Its length should be at least four characters.  If no id is
<span id="L63" class="LineNr"> 63 </span>   indicated, a null string is returned.
<span id="L64" class="LineNr"> 64 </span>code
<span id="L65" class="LineNr"> 65 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L66" class="LineNr"> 66 </span>
<span id="L67" class="LineNr"> 67 </span>
<span id="L68" class="LineNr"> 68 </span>:Entry:  decode_type:  05/04/83 ttt_info_$decode_type
<span id="L69" class="LineNr"> 69 </span>
<span id="L70" class="LineNr"> 70 </span>
<span id="L71" class="LineNr"> 71 </span>Function:  This entry point obtains the terminal type name that
<span id="L72" class="LineNr"> 72 </span>corresponds to a specified terminal type code number.
<span id="L73" class="LineNr"> 73 </span>
<span id="L74" class="LineNr"> 74 </span>
<span id="L75" class="LineNr"> 75 </span>Syntax:
<span id="L76" class="LineNr"> 76 </span>declare ttt_info_$decode_type entry <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L77" class="LineNr"> 77 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L78" class="LineNr"> 78 </span>call ttt_info_$decode_type <span class="textRainbow_lv0_p0">(</span>type_code<span class="textRainbow_lv0_o0">,</span> tt_name<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L79" class="LineNr"> 79 </span>
<span id="L80" class="LineNr"> 80 </span>
<span id="L81" class="LineNr"> 81 </span>Arguments:
<span id="L82" class="LineNr"> 82 </span>type_code
<span id="L83" class="LineNr"> 83 </span>   is the terminal type code number.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L84" class="LineNr"> 84 </span>tt_name
<span id="L85" class="LineNr"> 85 </span>   is the corresponding terminal type name.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L86" class="LineNr"> 86 </span>code
<span id="L87" class="LineNr"> 87 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L88" class="LineNr"> 88 </span>
<span id="L89" class="LineNr"> 89 </span>
<span id="L90" class="LineNr"> 90 </span>:Entry:  dialup_flags:  05/04/83 ttt_info_$dialup_flags
<span id="L91" class="LineNr"> 91 </span>
<span id="L92" class="LineNr"> 92 </span>
<span id="L93" class="LineNr"> 93 </span>Function:  This entry point returns the values of two flags for a
<span id="L94" class="LineNr"> 94 </span>specified terminal type.
<span id="L95" class="LineNr"> 95 </span>
<span id="L96" class="LineNr"> 96 </span>
<span id="L97" class="LineNr"> 97 </span>Syntax:
<span id="L98" class="LineNr"> 98 </span>declare ttt_info_$dialup_flags entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> bit<span class="textRainbow_lv1_p0">(</span>1<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> bit<span class="textRainbow_lv1_p0">(</span>1<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L99" class="LineNr"> 99 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L100" class="LineNr">100 </span>call ttt_info_$dialup_flags <span class="textRainbow_lv0_p0">(</span>tt_name<span class="textRainbow_lv0_o0">,</span> ppm_flag<span class="textRainbow_lv0_o0">,</span> cpo_flag<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L101" class="LineNr">101 </span>
<span id="L102" class="LineNr">102 </span>
<span id="L103" class="LineNr">103 </span>Arguments:
<span id="L104" class="LineNr">104 </span>tt_name
<span id="L105" class="LineNr">105 </span>   is the terminal type name.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L106" class="LineNr">106 </span>ppm_flag
<span id="L107" class="LineNr">107 </span>   indicates whether a preaccess message should be printed when an
<span id="L108" class="LineNr">108 </span>   unrecognizable login line is received from a terminal of the
<span id="L109" class="LineNr">109 </span>   specified type <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>:
<span id="L110" class="LineNr">110 </span>   &quot;1&quot;b   yes
<span id="L111" class="LineNr">111 </span>   &quot;0&quot;b   no
<span id="L112" class="LineNr">112 </span>cpo_flag
<span id="L113" class="LineNr">113 </span>   indicates whether &quot;conditional printer off&quot; is defined for the
<span id="L114" class="LineNr">114 </span>   terminal type; i.e., if the answerback indicates whether a terminal
<span id="L115" class="LineNr">115 </span>   is equipped with the printer off feature <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>:
<span id="L116" class="LineNr">116 </span>   &quot;1&quot;b   yes
<span id="L117" class="LineNr">117 </span>   &quot;0&quot;b   no
<span id="L118" class="LineNr">118 </span>code
<span id="L119" class="LineNr">119 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L120" class="LineNr">120 </span>
<span id="L121" class="LineNr">121 </span>
<span id="L122" class="LineNr">122 </span>:Entry:  encode_type:  05/04/83 ttt_info_$encode_type
<span id="L123" class="LineNr">123 </span>
<span id="L124" class="LineNr">124 </span>
<span id="L125" class="LineNr">125 </span>Function:  This entry point obtains a code number that corresponds to a
<span id="L126" class="LineNr">126 </span>specified terminal type name.
<span id="L127" class="LineNr">127 </span>
<span id="L128" class="LineNr">128 </span>
<span id="L129" class="LineNr">129 </span>Syntax:
<span id="L130" class="LineNr">130 </span>declare ttt_info_$encode_type entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span>
<span id="L131" class="LineNr">131 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L132" class="LineNr">132 </span>call ttt_info_$encode_type <span class="textRainbow_lv0_p0">(</span>tt_name<span class="textRainbow_lv0_o0">,</span> type_code<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L133" class="LineNr">133 </span>
<span id="L134" class="LineNr">134 </span>
<span id="L135" class="LineNr">135 </span>Arguments:
<span id="L136" class="LineNr">136 </span>tt_name
<span id="L137" class="LineNr">137 </span>   is the terminal type name.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L138" class="LineNr">138 </span>type_code
<span id="L139" class="LineNr">139 </span>   is the corresponding terminal type code number.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L140" class="LineNr">140 </span>code
<span id="L141" class="LineNr">141 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L142" class="LineNr">142 </span>
<span id="L143" class="LineNr">143 </span>
<span id="L144" class="LineNr">144 </span>:Entry:  function_key_data:  05/04/83 ttt_info_$function_key_data
<span id="L145" class="LineNr">145 </span>
<span id="L146" class="LineNr">146 </span>
<span id="L147" class="LineNr">147 </span>Function:  This entry point returns a collection of information
<span id="L148" class="LineNr">148 </span>describing the function keys of a specified terminal type.
<span id="L149" class="LineNr">149 </span>
<span id="L150" class="LineNr">150 </span>
<span id="L151" class="LineNr">151 </span>Syntax:
<span id="L152" class="LineNr">152 </span>dcl ttt_info_$function_key_data entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L153" class="LineNr">153 </span>     fixed bin <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L154" class="LineNr">154 </span>call ttt_info_$function_key_data <span class="textRainbow_lv0_p0">(</span>tt_name<span class="textRainbow_lv0_o0">,</span> areap<span class="textRainbow_lv0_o0">,</span>
<span id="L155" class="LineNr">155 </span>     function_key_data_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L156" class="LineNr">156 </span>
<span id="L157" class="LineNr">157 </span>
<span id="L158" class="LineNr">158 </span>Arguments:
<span id="L159" class="LineNr">159 </span>tt_name
<span id="L160" class="LineNr">160 </span>   is the terminal type name.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L161" class="LineNr">161 </span>areap
<span id="L162" class="LineNr">162 </span>   points to an area where the function_key_data info structure can be
<span id="L163" class="LineNr">163 </span>   allocated.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>.  If null, the system free area is used.  If the
<span id="L164" class="LineNr">164 </span>   area is not large enough, the area condition is signaled.
<span id="L165" class="LineNr">165 </span>function_key_data_ptr
<span id="L166" class="LineNr">166 </span>   points to the function_key_data structure allocated by this entry
<span id="L167" class="LineNr">167 </span>   point.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>.  The structure is described below.
<span id="L168" class="LineNr">168 </span>code
<span id="L169" class="LineNr">169 </span>   is a standard system status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L170" class="LineNr">170 </span>
<span id="L171" class="LineNr">171 </span>
<span id="L172" class="LineNr">172 </span>Data Structure:
<span id="L173" class="LineNr">173 </span>The data structure allocated by this routine is declared in the include
<span id="L174" class="LineNr">174 </span>file function_key_data.incl.pl1.
<span id="L175" class="LineNr">175 </span>   dcl 1 function_key_data aligned based <span class="textRainbow_lv0_p0">(</span>function_key_data_ptr<span class="textRainbow_lv0_p0">)</span>,
<span id="L176" class="LineNr">176 </span>         2 version fixed bin,
<span id="L177" class="LineNr">177 </span>         2 highest fixed bin,
<span id="L178" class="LineNr">178 </span>         2 sequence,
<span id="L179" class="LineNr">179 </span>           3 seq_ptr pointer,
<span id="L180" class="LineNr">180 </span>           3 seq_len fixed bin <span class="textRainbow_lv0_p0">(</span>21<span class="textRainbow_lv0_p0">)</span>,
<span id="L181" class="LineNr">181 </span>         2 cursor_motion_keys,
<span id="L182" class="LineNr">182 </span>           3 home <span class="textRainbow_lv0_p0">(</span>0:3<span class="textRainbow_lv0_p0">)</span> like key_info,
<span id="L183" class="LineNr">183 </span>           3 left <span class="textRainbow_lv0_p0">(</span>0:3<span class="textRainbow_lv0_p0">)</span> like key_info,
<span id="L184" class="LineNr">184 </span>           3 up <span class="textRainbow_lv0_p0">(</span>0:3<span class="textRainbow_lv0_p0">)</span> like key_info,
<span id="L185" class="LineNr">185 </span>           3 right <span class="textRainbow_lv0_p0">(</span>0:3<span class="textRainbow_lv0_p0">)</span> like key_info,
<span id="L186" class="LineNr">186 </span>           3 down <span class="textRainbow_lv0_p0">(</span>0:3<span class="textRainbow_lv0_p0">)</span> like key_info,
<span id="L187" class="LineNr">187 </span>         2 function_keys <span class="textRainbow_lv0_p0">(</span>0:function_key_data_highest refer
<span id="L188" class="LineNr">188 </span>            <span class="textRainbow_lv1_p0">(</span>function_key_data.highest<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> 0:3<span class="textRainbow_lv0_p0">)</span> like key_info;
<span id="L189" class="LineNr">189 </span>
<span id="L190" class="LineNr">190 </span>
<span id="L191" class="LineNr">191 </span>   dcl <span class="textRainbow_lv0_p0">(</span>KEY_PLAIN init <span class="textRainbow_lv1_p0">(</span>0<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L192" class="LineNr">192 </span>        KEY_SHIFT init <span class="textRainbow_lv1_p0">(</span>1<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L193" class="LineNr">193 </span>        KEY_CTRL init <span class="textRainbow_lv1_p0">(</span>2<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L194" class="LineNr">194 </span>        KEY_CTRL_AND_SHIFT init <span class="textRainbow_lv1_p0">(</span>3<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L195" class="LineNr">195 </span>         fixed bin internal static options <span class="textRainbow_lv0_p0">(</span>constant<span class="textRainbow_lv0_p0">)</span>;
<span id="L196" class="LineNr">196 </span>
<span id="L197" class="LineNr">197 </span>   dcl 1 key_info unaligned based <span class="textRainbow_lv0_p0">(</span>key_info_ptr<span class="textRainbow_lv0_p0">)</span>,
<span id="L198" class="LineNr">198 </span>         2 sequence_index fixed bin <span class="textRainbow_lv0_p0">(</span>12<span class="textRainbow_lv0_p0">)</span> unsigned unaligned,
<span id="L199" class="LineNr">199 </span>         2 sequence_length fixed bin <span class="textRainbow_lv0_p0">(</span>6<span class="textRainbow_lv0_p0">)</span> unsigned unaligned;
<span id="L200" class="LineNr">200 </span>
<span id="L201" class="LineNr">201 </span>
<span id="L202" class="LineNr">202 </span>   Structure elements:
<span id="L203" class="LineNr">203 </span>   version
<span id="L204" class="LineNr">204 </span>      is the version of this structure.  It should be set to
<span id="L205" class="LineNr">205 </span>      function_key_data_version_1.
<span id="L206" class="LineNr">206 </span>   highest
<span id="L207" class="LineNr">207 </span>      is the number of the highest function key defined.
<span id="L208" class="LineNr">208 </span>   sequence
<span id="L209" class="LineNr">209 </span>      defines the character string holding the concatenation of all the
<span id="L210" class="LineNr">210 </span>      sequences.  The sequence for a given key is defined as a
<span id="L211" class="LineNr">211 </span>      substring of this string.
<span id="L212" class="LineNr">212 </span>   seq_ptr
<span id="L213" class="LineNr">213 </span>      is the address of the string.
<span id="L214" class="LineNr">214 </span>   seq_len
<span id="L215" class="LineNr">215 </span>      is its length.
<span id="L216" class="LineNr">216 </span>
<span id="L217" class="LineNr">217 </span>
<span id="L218" class="LineNr">218 </span>   cursor_motion_keys
<span id="L219" class="LineNr">219 </span>      defines some miscellaneous keys whose names connote motion of the
<span id="L220" class="LineNr">220 </span>      cursor.  Note that the meaning of these keys is defined only by
<span id="L221" class="LineNr">221 </span>      the application, which may or may not choose to take advantage of
<span id="L222" class="LineNr">222 </span>      the mnemonic value of these key legends.
<span id="L223" class="LineNr">223 </span>   home
<span id="L224" class="LineNr">224 </span>      defines the sequences for the HOME key, used by itself, with
<span id="L225" class="LineNr">225 </span>      SHIFT, with CONTROL, and with SHIFT and CONTROL.  An absent
<span id="L226" class="LineNr">226 </span>      sequence has a sequence length of zero.
<span id="L227" class="LineNr">227 </span>   left
<span id="L228" class="LineNr">228 </span>      defines the left arrow key in the same way as HOME is defined.
<span id="L229" class="LineNr">229 </span>   up
<span id="L230" class="LineNr">230 </span>      defines the up-arrow key.
<span id="L231" class="LineNr">231 </span>
<span id="L232" class="LineNr">232 </span>
<span id="L233" class="LineNr">233 </span>   right
<span id="L234" class="LineNr">234 </span>      defines the right-arrow key.
<span id="L235" class="LineNr">235 </span>   down
<span id="L236" class="LineNr">236 </span>      defines the down-arrow key.
<span id="L237" class="LineNr">237 </span>   function_keys
<span id="L238" class="LineNr">238 </span>      defines the sequences for the function keys of the terminal.  If
<span id="L239" class="LineNr">239 </span>      the terminal has no function key labelled &quot;0&quot;, all sequences for
<span id="L240" class="LineNr">240 </span>      0 have zero length.
<span id="L241" class="LineNr">241 </span>   key_info
<span id="L242" class="LineNr">242 </span>      defines a given sequence.
<span id="L243" class="LineNr">243 </span>   sequence_index
<span id="L244" class="LineNr">244 </span>      is the index of the beginning of the sequence in the string of
<span id="L245" class="LineNr">245 </span>      all sequences.
<span id="L246" class="LineNr">246 </span>   sequence_length
<span id="L247" class="LineNr">247 </span>      is the length of the sequence.  If zero, the sequence is not
<span id="L248" class="LineNr">248 </span>      present.
<span id="L249" class="LineNr">249 </span>
<span id="L250" class="LineNr">250 </span>
<span id="L251" class="LineNr">251 </span>Notes:
<span id="L252" class="LineNr">252 </span>Mnemonic values are defined for the subscripts for various key
<span id="L253" class="LineNr">253 </span>combinations:  KEY_PLAIN, KEY_SHIFT, KEY_CTRL, and KEY_CTRL_AND_SHIFT.
<span id="L254" class="LineNr">254 </span>For example, the sequence for the left-arrow key with SHIFT is:
<span id="L255" class="LineNr">255 </span>   substr <span class="textRainbow_lv0_p0">(</span>function_key_seqs<span class="textRainbow_lv0_o0">,</span>
<span id="L256" class="LineNr">256 </span>      function_key_data.left<span class="textRainbow_lv1_p0">(</span>KEY_SHIFT<span class="textRainbow_lv1_p0">)</span>.sequence_offset<span class="textRainbow_lv0_o0">,</span>
<span id="L257" class="LineNr">257 </span>      function_key_data.left<span class="textRainbow_lv1_p0">(</span>KEY_SHIFT<span class="textRainbow_lv1_p0">)</span>.sequence_length<span class="textRainbow_lv0_p0">)</span>
<span id="L258" class="LineNr">258 </span>
<span id="L259" class="LineNr">259 </span>
<span id="L260" class="LineNr">260 </span>:Entry:  initial_string:  05/04/83 ttt_info_$initial_string
<span id="L261" class="LineNr">261 </span>
<span id="L262" class="LineNr">262 </span>
<span id="L263" class="LineNr">263 </span>Function:  This entry point returns a string that can be used to
<span id="L264" class="LineNr">264 </span>initialize terminals of a specified terminal type.  The string must be
<span id="L265" class="LineNr">265 </span>transmitted to the terminal in raw output <span class="textRainbow_lv0_p0">(</span>rawo<span class="textRainbow_lv0_p0">)</span> mode.  The initial
<span id="L266" class="LineNr">266 </span>string is most commonly used to set tabs on terminals that support tabs
<span id="L267" class="LineNr">267 </span>set by software.
<span id="L268" class="LineNr">268 </span>
<span id="L269" class="LineNr">269 </span>
<span id="L270" class="LineNr">270 </span>Syntax:
<span id="L271" class="LineNr">271 </span>declare ttt_info_$initial_string entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span> varying<span class="textRainbow_lv0_o0">,</span>
<span id="L272" class="LineNr">272 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L273" class="LineNr">273 </span>call ttt_info_$initial_string <span class="textRainbow_lv0_p0">(</span>tt_name<span class="textRainbow_lv0_o0">,</span> istr_info<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L274" class="LineNr">274 </span>
<span id="L275" class="LineNr">275 </span>
<span id="L276" class="LineNr">276 </span>Arguments:
<span id="L277" class="LineNr">277 </span>tt_name
<span id="L278" class="LineNr">278 </span>   is the terminal type name.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L279" class="LineNr">279 </span>istr_info
<span id="L280" class="LineNr">280 </span>   is the initial string.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>.  If no initial string is defined
<span id="L281" class="LineNr">281 </span>   for the terminal type, a null string is returned.  Maximum length is
<span id="L282" class="LineNr">282 </span>   512 characters.
<span id="L283" class="LineNr">283 </span>code
<span id="L284" class="LineNr">284 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L285" class="LineNr">285 </span>
<span id="L286" class="LineNr">286 </span>
<span id="L287" class="LineNr">287 </span>:Entry:  modes:  05/04/83 ttt_info_$modes
<span id="L288" class="LineNr">288 </span>
<span id="L289" class="LineNr">289 </span>
<span id="L290" class="LineNr">290 </span>Function:  This entry point returns the default modes for a specified
<span id="L291" class="LineNr">291 </span>terminal type.
<span id="L292" class="LineNr">292 </span>
<span id="L293" class="LineNr">293 </span>
<span id="L294" class="LineNr">294 </span>Syntax:
<span id="L295" class="LineNr">295 </span>declare ttt_info_$modes entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L296" class="LineNr">296 </span>call ttt_info_$modes <span class="textRainbow_lv0_p0">(</span>tt_name<span class="textRainbow_lv0_o0">,</span> modes<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L297" class="LineNr">297 </span>
<span id="L298" class="LineNr">298 </span>
<span id="L299" class="LineNr">299 </span>Arguments:
<span id="L300" class="LineNr">300 </span>tt_name
<span id="L301" class="LineNr">301 </span>   is the terminal type name.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L302" class="LineNr">302 </span>modes
<span id="L303" class="LineNr">303 </span>   is the default modes string for the terminal type.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>.  If
<span id="L304" class="LineNr">304 </span>   its length is less than 256 characters, the entire modes string is
<span id="L305" class="LineNr">305 </span>   not necessarily returned.
<span id="L306" class="LineNr">306 </span>code
<span id="L307" class="LineNr">307 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L308" class="LineNr">308 </span>
<span id="L309" class="LineNr">309 </span>
<span id="L310" class="LineNr">310 </span>:Entry:  preaccess_type:  05/04/83 ttt_info_$preaccess_type
<span id="L311" class="LineNr">311 </span>
<span id="L312" class="LineNr">312 </span>
<span id="L313" class="LineNr">313 </span>Function:  This entry point returns the terminal type name associated
<span id="L314" class="LineNr">314 </span>with a specified preaccess request.
<span id="L315" class="LineNr">315 </span>
<span id="L316" class="LineNr">316 </span>
<span id="L317" class="LineNr">317 </span>Syntax:
<span id="L318" class="LineNr">318 </span>declare ttt_info_$preaccess_type entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L319" class="LineNr">319 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L320" class="LineNr">320 </span>call ttt_info_$preaccess_type <span class="textRainbow_lv0_p0">(</span>request<span class="textRainbow_lv0_o0">,</span> tt_name<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>);
<span id="L321" class="LineNr">321 </span>
<span id="L322" class="LineNr">322 </span>
<span id="L323" class="LineNr">323 </span>Arguments:
<span id="L324" class="LineNr">324 </span>request
<span id="L325" class="LineNr">325 </span>   is one of the following three preaccess requests:  MAP, 963, or 029.
<span id="L326" class="LineNr">326 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L327" class="LineNr">327 </span>tt_name
<span id="L328" class="LineNr">328 </span>   is the name of the associated terminal type.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>.  Its length
<span id="L329" class="LineNr">329 </span>   should be at least 32 characters.
<span id="L330" class="LineNr">330 </span>code
<span id="L331" class="LineNr">331 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L332" class="LineNr">332 </span>
<span id="L333" class="LineNr">333 </span>
<span id="L334" class="LineNr">334 </span>:Entry:  terminal_data:  05/04/83 ttt_info_$terminal_data
<span id="L335" class="LineNr">335 </span>
<span id="L336" class="LineNr">336 </span>
<span id="L337" class="LineNr">337 </span>Function:  This entry point returns a collection of information that
<span id="L338" class="LineNr">338 </span>describes a specified terminal type.
<span id="L339" class="LineNr">339 </span>
<span id="L340" class="LineNr">340 </span>
<span id="L341" class="LineNr">341 </span>Syntax:
<span id="L342" class="LineNr">342 </span>declare ttt_info_$terminal_data entry <span class="textRainbow_lv0_p0">(</span>char<span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span>
<span id="L343" class="LineNr">343 </span>     ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L344" class="LineNr">344 </span>call ttt_info_$terminal_data <span class="textRainbow_lv0_p0">(</span>tt_name<span class="textRainbow_lv0_o0">,</span> line_type<span class="textRainbow_lv0_o0">,</span> baud<span class="textRainbow_lv0_o0">,</span> ttd_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L345" class="LineNr">345 </span>
<span id="L346" class="LineNr">346 </span>
<span id="L347" class="LineNr">347 </span>Arguments:
<span id="L348" class="LineNr">348 </span>tt_name
<span id="L349" class="LineNr">349 </span>   is the terminal type name.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L350" class="LineNr">350 </span>line_type
<span id="L351" class="LineNr">351 </span>   is a line type number against which the compatibility of the
<span id="L352" class="LineNr">352 </span>   terminal type is verified.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>.  If nonpositive, the line type
<span id="L353" class="LineNr">353 </span>   number is ignored.  For further description, see the tty_ I/O
<span id="L354" class="LineNr">354 </span>   module.
<span id="L355" class="LineNr">355 </span>baud
<span id="L356" class="LineNr">356 </span>   is a baud rate used to select the appropriate delay table.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L357" class="LineNr">357 </span>ttd_ptr
<span id="L358" class="LineNr">358 </span>   is a pointer to a structure in which information is returned.
<span id="L359" class="LineNr">359 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>.  <span class="textRainbow_lv0_p0">(</span>See &quot;Notes&quot; below.<span class="textRainbow_lv0_p0">)</span>
<span id="L360" class="LineNr">360 </span>code
<span id="L361" class="LineNr">361 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>.  If the terminal type is
<span id="L362" class="LineNr">362 </span>   incompatible with the line type, a value of
<span id="L363" class="LineNr">363 </span>   error_table_$incompatible_term_type is returned.
<span id="L364" class="LineNr">364 </span>
<span id="L365" class="LineNr">365 </span>
<span id="L366" class="LineNr">366 </span>Notes:
<span id="L367" class="LineNr">367 </span>The ttd_ptr argument should point to the following structure
<span id="L368" class="LineNr">368 </span><span class="textRainbow_lv0_p0">(</span>terminal_type_data.incl.pl1<span class="textRainbow_lv0_p0">)</span>:
<span id="L369" class="LineNr">369 </span>   dcl 1 terminal_type_data             aligned,
<span id="L370" class="LineNr">370 </span>         2 version                      fixed bin,
<span id="L371" class="LineNr">371 </span>         2 old_type                     fixed bin,
<span id="L372" class="LineNr">372 </span>         2 name                         char<span class="textRainbow_lv0_p0">(</span>32<span class="textRainbow_lv0_p0">)</span> unaligned,
<span id="L373" class="LineNr">373 </span>         2 tables,
<span id="L374" class="LineNr">374 </span>           3 input_tr_ptr               ptr,
<span id="L375" class="LineNr">375 </span>           3 output_tr_ptr              ptr,
<span id="L376" class="LineNr">376 </span>           3 input_cv_ptr               ptr,
<span id="L377" class="LineNr">377 </span>           3 output_cv_ptr              ptr,
<span id="L378" class="LineNr">378 </span>           3 special_ptr                ptr,
<span id="L379" class="LineNr">379 </span>           3 delay_ptr                  ptr,
<span id="L380" class="LineNr">380 </span>         2 editing_chars                unaligned,
<span id="L381" class="LineNr">381 </span>           3 erase char<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span>              unaligned,
<span id="L382" class="LineNr">382 </span>           3 kill char<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span>               unaligned,
<span id="L383" class="LineNr">383 </span>
<span id="L384" class="LineNr">384 </span>
<span id="L385" class="LineNr">385 </span>         2 framing_chars                unaligned,
<span id="L386" class="LineNr">386 </span>           3 frame_begin                char<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unaligned,
<span id="L387" class="LineNr">387 </span>           3 frame_end                  char<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unaligned,
<span id="L388" class="LineNr">388 </span>         2 flags,                       unaligned,
<span id="L389" class="LineNr">389 </span>           3 keyboard_locking           bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span>,
<span id="L390" class="LineNr">390 </span>           3 input_timeout              bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span>,
<span id="L391" class="LineNr">391 </span>           3 output_block_acknowledge   bit<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span>,
<span id="L392" class="LineNr">392 </span>           3 mbz                        bit<span class="textRainbow_lv0_p0">(</span>15<span class="textRainbow_lv0_p0">)</span>,
<span id="L393" class="LineNr">393 </span>         2 line_delimiter               char<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unaligned,
<span id="L394" class="LineNr">394 </span>         2 mbz                          bit<span class="textRainbow_lv0_p0">(</span>9<span class="textRainbow_lv0_p0">)</span> unaligned,
<span id="L395" class="LineNr">395 </span>         2 flow_control_chars           unaligned,
<span id="L396" class="LineNr">396 </span>           3 input_suspend              char<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span>,
<span id="L397" class="LineNr">397 </span>           3 input_resume               char<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span>,
<span id="L398" class="LineNr">398 </span>           3 output_suspend_etb         char<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span>,
<span id="L399" class="LineNr">399 </span>           3 output_resume_ack          char<span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span>,
<span id="L400" class="LineNr">400 </span>         2 output_buffer_size           fixed bin;
<span id="L401" class="LineNr">401 </span>
<span id="L402" class="LineNr">402 </span>
<span id="L403" class="LineNr">403 </span>   Structure elements:
<span id="L404" class="LineNr">404 </span>   version
<span id="L405" class="LineNr">405 </span>      is the version number of the above structure.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>.  It must
<span id="L406" class="LineNr">406 </span>      be 1 or 2.
<span id="L407" class="LineNr">407 </span>   old_type
<span id="L408" class="LineNr">408 </span>      is the old terminal type number that corresponds to the terminal
<span id="L409" class="LineNr">409 </span>      type name.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>.  <span class="textRainbow_lv0_p0">(</span>The old terminal type number is provided
<span id="L410" class="LineNr">410 </span>      only for compatibility with the obsolete set_type and info tty_
<span id="L411" class="LineNr">411 </span>      order requests.<span class="textRainbow_lv0_p0">)</span>  A value of -1 indicates that no corresponding
<span id="L412" class="LineNr">412 </span>      old type exists.
<span id="L413" class="LineNr">413 </span>   name
<span id="L414" class="LineNr">414 </span>      is the terminal type name.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L415" class="LineNr">415 </span>
<span id="L416" class="LineNr">416 </span>
<span id="L417" class="LineNr">417 </span>   input_tr_ptr
<span id="L418" class="LineNr">418 </span>      is a pointer to a structure containing the input translation
<span id="L419" class="LineNr">419 </span>      table.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>.  This structure is identical to the info
<span id="L420" class="LineNr">420 </span>      structure for the set_input_translation order of the tty_ I/O
<span id="L421" class="LineNr">421 </span>      module.
<span id="L422" class="LineNr">422 </span>   output_tr_ptr
<span id="L423" class="LineNr">423 </span>      is a pointer to a structure containing the output translation
<span id="L424" class="LineNr">424 </span>      table.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>.  This structure is identical to the info
<span id="L425" class="LineNr">425 </span>      structure for the set_output_translation order of the tty_ I/O
<span id="L426" class="LineNr">426 </span>      module.
<span id="L427" class="LineNr">427 </span>   input_cv_ptr
<span id="L428" class="LineNr">428 </span>      is a pointer to a structure containing the input conversion
<span id="L429" class="LineNr">429 </span>      table.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>.  This structure is identical to the info
<span id="L430" class="LineNr">430 </span>      structure for the set_input_conversion order of the tty_ I/O
<span id="L431" class="LineNr">431 </span>      module.
<span id="L432" class="LineNr">432 </span>
<span id="L433" class="LineNr">433 </span>
<span id="L434" class="LineNr">434 </span>   output_cv_ptr
<span id="L435" class="LineNr">435 </span>      is a pointer to a structure containing the output conversion
<span id="L436" class="LineNr">436 </span>      table.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>.  This structure is identical to the info
<span id="L437" class="LineNr">437 </span>      structure for the set_output_conversion order of the tty_ I/O
<span id="L438" class="LineNr">438 </span>      module.
<span id="L439" class="LineNr">439 </span>   special_ptr
<span id="L440" class="LineNr">440 </span>      is a pointer to a structure containing the special characters
<span id="L441" class="LineNr">441 </span>      table.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>.  This structure is identical to the info
<span id="L442" class="LineNr">442 </span>      structure for the set_special order of the tty_ I/O module.
<span id="L443" class="LineNr">443 </span>   delay_ptr
<span id="L444" class="LineNr">444 </span>      is a pointer to a structure containing the delay table.
<span id="L445" class="LineNr">445 </span>      <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>.  This structure is identical to the info structure for
<span id="L446" class="LineNr">446 </span>      the set_delay order of the tty_ I/O module.
<span id="L447" class="LineNr">447 </span>   erase
<span id="L448" class="LineNr">448 </span>      is the erase character.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L449" class="LineNr">449 </span>
<span id="L450" class="LineNr">450 </span>
<span id="L451" class="LineNr">451 </span>   kill
<span id="L452" class="LineNr">452 </span>      is the kill character.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L453" class="LineNr">453 </span>   frame_begin
<span id="L454" class="LineNr">454 </span>      is the frame-begin character.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L455" class="LineNr">455 </span>   frame_end
<span id="L456" class="LineNr">456 </span>      is the frame-end character.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L457" class="LineNr">457 </span>   keyboard_locking
<span id="L458" class="LineNr">458 </span>      indicates whether the terminal type requires keyboard locking and
<span id="L459" class="LineNr">459 </span>      unlocking.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L460" class="LineNr">460 </span>      &quot;1&quot;b   yes
<span id="L461" class="LineNr">461 </span>      &quot;0&quot;b   no
<span id="L462" class="LineNr">462 </span>
<span id="L463" class="LineNr">463 </span>
<span id="L464" class="LineNr">464 </span>   input_timeout
<span id="L465" class="LineNr">465 </span>      is &quot;1&quot;b if the timeout option was specified on an input_resume
<span id="L466" class="LineNr">466 </span>      statement in the TTF.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L467" class="LineNr">467 </span>   output_block_acknowledge
<span id="L468" class="LineNr">468 </span>      is &quot;1&quot;b if output_end_of_block and output_acknowledge statements
<span id="L469" class="LineNr">469 </span>      were specified in the TTF.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L470" class="LineNr">470 </span>   mbz
<span id="L471" class="LineNr">471 </span>      must be &quot;0&quot;b.
<span id="L472" class="LineNr">472 </span>   line_delimiter
<span id="L473" class="LineNr">473 </span>      is the line delimiter character.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L474" class="LineNr">474 </span>
<span id="L475" class="LineNr">475 </span>
<span id="L476" class="LineNr">476 </span>   The remaining elements are not present if version <span class="textRainbow_lv0_p0">(</span>above<span class="textRainbow_lv0_p0">)</span> is 1.
<span id="L477" class="LineNr">477 </span>   flow_control_chars
<span id="L478" class="LineNr">478 </span>      identifies the flow control characters.
<span id="L479" class="LineNr">479 </span>   input_suspend
<span id="L480" class="LineNr">480 </span>      is the character sent to the terminal to suspend input, or sent
<span id="L481" class="LineNr">481 </span>      by the terminal to indicate that it is suspending input.
<span id="L482" class="LineNr">482 </span>      <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L483" class="LineNr">483 </span>   input_resume
<span id="L484" class="LineNr">484 </span>      is the character sent to the terminal to resume input.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L485" class="LineNr">485 </span>   output_suspend_etb
<span id="L486" class="LineNr">486 </span>      is the character sent by the terminal to suspend output if
<span id="L487" class="LineNr">487 </span>      output_block_acknowledge is &quot;0&quot;b; otherwise, it is the character
<span id="L488" class="LineNr">488 </span>      to be appended to each output block.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L489" class="LineNr">489 </span>
<span id="L490" class="LineNr">490 </span>
<span id="L491" class="LineNr">491 </span>   output_resume_ack
<span id="L492" class="LineNr">492 </span>      is the character sent by the terminal to resume output if
<span id="L493" class="LineNr">493 </span>      output_block_acknowledge is &quot;0&quot;b; otherwise, it is the character
<span id="L494" class="LineNr">494 </span>      used to acknowledge an output block.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L495" class="LineNr">495 </span>   output_buffer_size
<span id="L496" class="LineNr">496 </span>      is the size, in characters, of the terminal's buffer, for use
<span id="L497" class="LineNr">497 </span>      with a block acknowledgement protocol.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>.  It is 0 unless
<span id="L498" class="LineNr">498 </span>      output_block_acknowledge is &quot;1&quot;b.
<span id="L499" class="LineNr">499 </span>
<span id="L500" class="LineNr">500 </span>
<span id="L501" class="LineNr">501 </span>:Entry:  video_info:  05/04/83 ttt_info_$video_info
<span id="L502" class="LineNr">502 </span>
<span id="L503" class="LineNr">503 </span>
<span id="L504" class="LineNr">504 </span>Function:  This entry point is used to obtain a copy of the video
<span id="L505" class="LineNr">505 </span>sequences table for a particular terminal type.
<span id="L506" class="LineNr">506 </span>
<span id="L507" class="LineNr">507 </span>
<span id="L508" class="LineNr">508 </span>Syntax:
<span id="L509" class="LineNr">509 </span>declare ttt_info_$video_info entry <span class="textRainbow_lv0_p0">(</span>char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L510" class="LineNr">510 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L511" class="LineNr">511 </span>call ttt_info_$video_info <span class="textRainbow_lv0_p0">(</span>terminal_type<span class="textRainbow_lv0_o0">,</span> baud_rate<span class="textRainbow_lv0_o0">,</span> areap<span class="textRainbow_lv0_o0">,</span>
<span id="L512" class="LineNr">512 </span>     tty_vtbl_ptr<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L513" class="LineNr">513 </span>
<span id="L514" class="LineNr">514 </span>
<span id="L515" class="LineNr">515 </span>Arguments:
<span id="L516" class="LineNr">516 </span>terminal_type
<span id="L517" class="LineNr">517 </span>   is the name of the terminal type for which the video table is
<span id="L518" class="LineNr">518 </span>   required.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L519" class="LineNr">519 </span>baud_rate
<span id="L520" class="LineNr">520 </span>   is the current baud rate of the terminal.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>.  This can be set
<span id="L521" class="LineNr">521 </span>   to 0 if it is unknown.
<span id="L522" class="LineNr">522 </span>area
<span id="L523" class="LineNr">523 </span>   is a pointer to an area where the video table may be allocated.
<span id="L524" class="LineNr">524 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>.  If null, the system free area is used.
<span id="L525" class="LineNr">525 </span>tty_vtbl_ptr
<span id="L526" class="LineNr">526 </span>   is a pointer to the video table, if present.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L527" class="LineNr">527 </span>code
<span id="L528" class="LineNr">528 </span>   is a standard system status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L529" class="LineNr">529 </span>
<span id="L530" class="LineNr">530 </span>
<span id="L531" class="LineNr">531 </span>Notes:
<span id="L532" class="LineNr">532 </span>The format of a video table is given in the include file
<span id="L533" class="LineNr">533 </span>tty_video_tables.incl.pl1.
<span id="L534" class="LineNr">534 </span>   dcl 1 tty_video_table          aligned based <span class="textRainbow_lv0_p0">(</span>ttyvtblp<span class="textRainbow_lv0_p0">)</span>,
<span id="L535" class="LineNr">535 </span>         2 version                fixed bin,
<span id="L536" class="LineNr">536 </span>         2 screen_height          fixed bin,
<span id="L537" class="LineNr">537 </span>         2 screen_line_length     fixed bin,
<span id="L538" class="LineNr">538 </span>         2 scroll_count           fixed bin,
<span id="L539" class="LineNr">539 </span>         2 flags                  unaligned,
<span id="L540" class="LineNr">540 </span>           3 overstrike_available bit <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L541" class="LineNr">541 </span>           3 automatic_crlf       bit <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L542" class="LineNr">542 </span>           3 simulate_eol         bit <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L543" class="LineNr">543 </span>           3 pad                  bit <span class="textRainbow_lv0_p0">(</span>33<span class="textRainbow_lv0_p0">)</span> unaligned,
<span id="L544" class="LineNr">544 </span>
<span id="L545" class="LineNr">545 </span>
<span id="L546" class="LineNr">546 </span>         2 video_chars_len        fixed binary <span class="textRainbow_lv0_p0">(</span>21<span class="textRainbow_lv0_p0">)</span>
<span id="L547" class="LineNr">547 </span>         2 pad                    <span class="textRainbow_lv0_p0">(</span>2<span class="textRainbow_lv0_p0">)</span> bin <span class="textRainbow_lv0_p0">(</span>36<span class="textRainbow_lv0_p0">)</span>
<span id="L548" class="LineNr">548 </span>         2 nseq                   fixed bin,
<span id="L549" class="LineNr">549 </span>         2 sequences              <span class="textRainbow_lv0_p0">(</span>N_VIDEO_SEQUENCES refer
<span id="L550" class="LineNr">550 </span>                                      <span class="textRainbow_lv1_p0">(</span>tty_video_table.nseq<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L551" class="LineNr">551 </span>                                   like tty_video_seq aligned,
<span id="L552" class="LineNr">552 </span>         2 video_chars         char <span class="textRainbow_lv0_p0">(</span>tty_video_table_video_chars_len
<span id="L553" class="LineNr">553 </span>                               refer <span class="textRainbow_lv1_p0">(</span>tty_video_table.video_chars_len<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>
<span id="L554" class="LineNr">554 </span>                                unal;
<span id="L555" class="LineNr">555 </span>
<span id="L556" class="LineNr">556 </span>
<span id="L557" class="LineNr">557 </span>   Structure elements:
<span id="L558" class="LineNr">558 </span>   version
<span id="L559" class="LineNr">559 </span>      is the version of this structure.  It must be
<span id="L560" class="LineNr">560 </span>      tty_video_tables_version_1, also declared in this include file.
<span id="L561" class="LineNr">561 </span>   screen_height
<span id="L562" class="LineNr">562 </span>      is the number of lines on this terminal.
<span id="L563" class="LineNr">563 </span>   screen_line_length
<span id="L564" class="LineNr">564 </span>      is the number of character positions <span class="textRainbow_lv0_p0">(</span>columns<span class="textRainbow_lv0_p0">)</span> in each line.
<span id="L565" class="LineNr">565 </span>   scroll_count
<span id="L566" class="LineNr">566 </span>      is the number of lines scrolled upward when a scroll command is
<span id="L567" class="LineNr">567 </span>      sent to the terminal <span class="textRainbow_lv0_p0">(</span>if the terminal is capable of scrolling<span class="textRainbow_lv0_p0">)</span>.
<span id="L568" class="LineNr">568 </span>      For most terminals this will be 1.  A value of 0 indicates that
<span id="L569" class="LineNr">569 </span>      one line is scrolled.
<span id="L570" class="LineNr">570 </span>
<span id="L571" class="LineNr">571 </span>
<span id="L572" class="LineNr">572 </span>   flags
<span id="L573" class="LineNr">573 </span>      describe characteristics of the terminal.
<span id="L574" class="LineNr">574 </span>   overstrike_available
<span id="L575" class="LineNr">575 </span>      is &quot;1&quot;b if the terminal can overstrike <span class="textRainbow_lv0_p0">(</span>i.e.<span class="textRainbow_lv0_o0">,</span> more than one
<span id="L576" class="LineNr">576 </span>      character can be seen in the same character position<span class="textRainbow_lv0_p0">)</span>.
<span id="L577" class="LineNr">577 </span>   automatic_crlf
<span id="L578" class="LineNr">578 </span>      is &quot;1&quot;b if the terminal performs a carriage return and line feed
<span id="L579" class="LineNr">579 </span>      when a character is displayed in the last column.
<span id="L580" class="LineNr">580 </span>   simulate_eol
<span id="L581" class="LineNr">581 </span>      is reserved for future expansion.
<span id="L582" class="LineNr">582 </span>   pad
<span id="L583" class="LineNr">583 </span>      has an undefined value, and is reserved for future expansion.
<span id="L584" class="LineNr">584 </span>   video_chars_len
<span id="L585" class="LineNr">585 </span>      specifies the length of the string containing all video
<span id="L586" class="LineNr">586 </span>      sequences.
<span id="L587" class="LineNr">587 </span>
<span id="L588" class="LineNr">588 </span>
<span id="L589" class="LineNr">589 </span>   pad
<span id="L590" class="LineNr">590 </span>      is reserved for future expansion.
<span id="L591" class="LineNr">591 </span>   nseq
<span id="L592" class="LineNr">592 </span>      is the number of the highest video sequence defined for this
<span id="L593" class="LineNr">593 </span>      terminal.  Not all sequences are defined for all terminals, so
<span id="L594" class="LineNr">594 </span>      programs should check this value before indexing the sequence
<span id="L595" class="LineNr">595 </span>      array.
<span id="L596" class="LineNr">596 </span>   sequences
<span id="L597" class="LineNr">597 </span>      is an array of video sequences.  Each element of the array
<span id="L598" class="LineNr">598 </span>      specifies the character sequence for a video control operation.
<span id="L599" class="LineNr">599 </span>      The indices for specific sequences are defined by constants also
<span id="L600" class="LineNr">600 </span>      declared in this include file.  See below.
<span id="L601" class="LineNr">601 </span>   video_chars
<span id="L602" class="LineNr">602 </span>      is a string holding concatenations of all video sequences.
<span id="L603" class="LineNr">603 </span>
<span id="L604" class="LineNr">604 </span>
<span id="L605" class="LineNr">605 </span>The include file defines values for the indices into the array of
<span id="L606" class="LineNr">606 </span>sequences for the video operations supported.  The names of these
<span id="L607" class="LineNr">607 </span>values are:  ABS_POS, CLEAR_SCREEN, CLEAR_TO_EOS, HOME, CLEAR_TO_EOL,
<span id="L608" class="LineNr">608 </span>CURSOR_UP, CURSOR_RIGHT, CURSOR_DOWN, CURSOR_LEFT, INSERT_CHARS,
<span id="L609" class="LineNr">609 </span>END_INSERT_CHARS, DELETE_CHARS, INSERT_LINES, DELETE_LINES.  The
<span id="L610" class="LineNr">610 </span>include file also defines N_VIDEO_SEQUENCES, which is the number of the
<span id="L611" class="LineNr">611 </span>highest index ever defined.
<span id="L612" class="LineNr">612 </span>
<span id="L613" class="LineNr">613 </span>
<span id="L614" class="LineNr">614 </span>A video sequence is defined by the tty_video_seq structure in the
<span id="L615" class="LineNr">615 </span>include file tty_video_tables.incl.pl1.
<span id="L616" class="LineNr">616 </span>   dcl 1 tty_video_seq based <span class="textRainbow_lv0_p0">(</span>ttyvseqp<span class="textRainbow_lv0_p0">)</span> aligned,
<span id="L617" class="LineNr">617 </span>         2 flags                 unaligned,
<span id="L618" class="LineNr">618 </span>           3 present             bit <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L619" class="LineNr">619 </span>           3 interpret           bit <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L620" class="LineNr">620 </span>           3 able_to_repeat      bit <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L621" class="LineNr">621 </span>           3 cpad_present        bit <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L622" class="LineNr">622 </span>           3 cpad_in_chars       bit <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L623" class="LineNr">623 </span>           3 pad                 bit <span class="textRainbow_lv0_p0">(</span>7<span class="textRainbow_lv0_p0">)</span> unaligned,
<span id="L624" class="LineNr">624 </span>           3 general             bit <span class="textRainbow_lv0_p0">(</span>6<span class="textRainbow_lv0_p0">)</span> unaligned,
<span id="L625" class="LineNr">625 </span>         2 cpad                  fixed bin <span class="textRainbow_lv0_p0">(</span>18<span class="textRainbow_lv0_p0">)</span> unsigned unaligned,
<span id="L626" class="LineNr">626 </span>         2 pad                   bit <span class="textRainbow_lv0_p0">(</span>15<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L627" class="LineNr">627 </span>         2 len                   fixed bin <span class="textRainbow_lv0_p0">(</span>9<span class="textRainbow_lv0_p0">)</span> unsigned unaligned,
<span id="L628" class="LineNr">628 </span>         2 seq_index             fixed bin <span class="textRainbow_lv0_p0">(</span>12<span class="textRainbow_lv0_p0">)</span> unsigned unaligned;
<span id="L629" class="LineNr">629 </span>
<span id="L630" class="LineNr">630 </span>
<span id="L631" class="LineNr">631 </span>   Structure elements:
<span id="L632" class="LineNr">632 </span>   present
<span id="L633" class="LineNr">633 </span>      is &quot;1&quot;b if the operation is supported.
<span id="L634" class="LineNr">634 </span>   interpret
<span id="L635" class="LineNr">635 </span>      is &quot;1&quot;b if the sequence contains the encoding of the line,
<span id="L636" class="LineNr">636 </span>      column, or repeat count and must be inspected more closely.
<span id="L637" class="LineNr">637 </span>   able_to_repeat
<span id="L638" class="LineNr">638 </span>      is &quot;1&quot;b if the terminal can perform multiple sequences of this
<span id="L639" class="LineNr">639 </span>      operation by receiving a single-character sequence containing the
<span id="L640" class="LineNr">640 </span>      repeat count that is encoded in the sequence.
<span id="L641" class="LineNr">641 </span>   cpad_present
<span id="L642" class="LineNr">642 </span>      is &quot;1&quot;b if the terminal requires padding after the operation.
<span id="L643" class="LineNr">643 </span>
<span id="L644" class="LineNr">644 </span>
<span id="L645" class="LineNr">645 </span>   cpad_in_chars
<span id="L646" class="LineNr">646 </span>      is &quot;1&quot;b if the padding is in characters, or &quot;0&quot;b if the padding
<span id="L647" class="LineNr">647 </span>      is in tenths of milliseconds.  If the baud rate is supplied to
<span id="L648" class="LineNr">648 </span>      the ttt_info_$video_info subroutine, then padding is always
<span id="L649" class="LineNr">649 </span>      expressed in characters.
<span id="L650" class="LineNr">650 </span>   pad
<span id="L651" class="LineNr">651 </span>      is reserved for future expansion.
<span id="L652" class="LineNr">652 </span>   general
<span id="L653" class="LineNr">653 </span>      is reserved for future expansion to define per-sequence
<span id="L654" class="LineNr">654 </span>      information.
<span id="L655" class="LineNr">655 </span>
<span id="L656" class="LineNr">656 </span>
<span id="L657" class="LineNr">657 </span>   cpad
<span id="L658" class="LineNr">658 </span>      is the padding count in units defined by cpad_in_chars.
<span id="L659" class="LineNr">659 </span>   pad
<span id="L660" class="LineNr">660 </span>      is reserved for future expansion.
<span id="L661" class="LineNr">661 </span>   len
<span id="L662" class="LineNr">662 </span>      is the length of the string of characters defining this sequence.
<span id="L663" class="LineNr">663 </span>   seq_index
<span id="L664" class="LineNr">664 </span>      is the index of the start of the string in
<span id="L665" class="LineNr">665 </span>      tty_video_table.video_chars.
<span id="L666" class="LineNr">666 </span>
<span id="L667" class="LineNr">667 </span>
<span id="L668" class="LineNr">668 </span>Many terminals allow a repetition count to be supplied with an
<span id="L669" class="LineNr">669 </span>operation <span class="textRainbow_lv0_p0">(</span>e.g.<span class="textRainbow_lv0_o0">,</span> to delete multiple lines<span class="textRainbow_lv0_p0">)</span>.  Positioning operations
<span id="L670" class="LineNr">670 </span>require line and column coordinates.  These values must be expressed in
<span id="L671" class="LineNr">671 </span>some encoding.  A variety of encodings are supported.  Parameters to be
<span id="L672" class="LineNr">672 </span>transmitted are specified by an encoding character in the video
<span id="L673" class="LineNr">673 </span>sequence string.  An encoding character is a nine-bit byte whose high
<span id="L674" class="LineNr">674 </span>order bit is set and is defined by the structure tty_numeric_encoding
<span id="L675" class="LineNr">675 </span>in the include file tty_video_tables.incl.pl1.  The encoding scheme is
<span id="L676" class="LineNr">676 </span>described in the write-up for the video_info table of the Terminal Type
<span id="L677" class="LineNr">677 </span>file in the Programmer's Reference Manual.
<span id="L678" class="LineNr">678 </span>   dcl 1 tty_numeric_encoding based unaligned,
<span id="L679" class="LineNr">679 </span>         2 flags,
<span id="L680" class="LineNr">680 </span>           3 must_be_on         bit <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L681" class="LineNr">681 </span>           3 express_in_decimal bit <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L682" class="LineNr">682 </span>           3 express_in_octal   bit <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L683" class="LineNr">683 </span>           3 offset_is_0        bit <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unal,
<span id="L684" class="LineNr">684 </span>         2 l_c_or_n             fixed bin <span class="textRainbow_lv0_p0">(</span>2<span class="textRainbow_lv0_p0">)</span> unsigned unaligned,
<span id="L685" class="LineNr">685 </span>         2 num_digits           fixed bin <span class="textRainbow_lv0_p0">(</span>2<span class="textRainbow_lv0_p0">)</span> unsigned unaligned,
<span id="L686" class="LineNr">686 </span>         2 pad                  bit <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> unaligned
<span id="L687" class="LineNr">687 </span>         2 offset               fixed bin <span class="textRainbow_lv0_p0">(</span>8<span class="textRainbow_lv0_p0">)</span> unaligned;
<span id="L688" class="LineNr">688 </span>
<span id="L689" class="LineNr">689 </span>
<span id="L690" class="LineNr">690 </span>   Structure elements:
<span id="L691" class="LineNr">691 </span>   must_be_on
<span id="L692" class="LineNr">692 </span>      is &quot;1&quot;b for an encoding character.
<span id="L693" class="LineNr">693 </span>   express_in_decimal
<span id="L694" class="LineNr">694 </span>      is &quot;1&quot;b if the value should be expressed as decimal digits.
<span id="L695" class="LineNr">695 </span>   express_in_octal
<span id="L696" class="LineNr">696 </span>      is &quot;1&quot;b if the value should be expressed in octal digits.  If
<span id="L697" class="LineNr">697 </span>      both flags are off, the value should be sent as a single
<span id="L698" class="LineNr">698 </span>      character.
<span id="L699" class="LineNr">699 </span>   offset_is_0
<span id="L700" class="LineNr">700 </span>      if &quot;0&quot;b, the following byte is a fixed bin<span class="textRainbow_lv0_p0">(</span>8<span class="textRainbow_lv0_p0">)</span> value to be added
<span id="L701" class="LineNr">701 </span>      to the value before encoding.  If &quot;1&quot;b, the offset is 0, and the
<span id="L702" class="LineNr">702 </span>      next byte has no special significance.
<span id="L703" class="LineNr">703 </span>
<span id="L704" class="LineNr">704 </span>
<span id="L705" class="LineNr">705 </span>   l_c_or_n
<span id="L706" class="LineNr">706 </span>      specifies the type of value to be encoded.  Its value can be 0,
<span id="L707" class="LineNr">707 </span>      1, or 2, and indicates that this encoding character specifies the
<span id="L708" class="LineNr">708 </span>      line number, column number, or repeat count, respectively.
<span id="L709" class="LineNr">709 </span>   num_digits
<span id="L710" class="LineNr">710 </span>      specifies the number of digits to be sent.  A value of 0 causes
<span id="L711" class="LineNr">711 </span>      all significant digits to be sent, with leading zeroes
<span id="L712" class="LineNr">712 </span>      suppressed.
<span id="L713" class="LineNr">713 </span>   pad
<span id="L714" class="LineNr">714 </span>      is reserved for future expansion.
<span id="L715" class="LineNr">715 </span>   offset
<span id="L716" class="LineNr">716 </span>      is present only if offset_is_0 is &quot;0&quot;b.  It gives an offset to be
<span id="L717" class="LineNr">717 </span>      added to the value before expressing it in octal or decimal.
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
